
<h1>Дробные товары</h1>
<div class=" form zzzfractional_plugin-settings">
    <div class="zzzfractional-update-message"></div>
    <form action="?plugin=zzzfractional&action=settings" method="post" id="plugin-settings-form">
        {$wa->csrf()}

        <div class="block double-padded blocks-tabs">
            <ul class="menu-h menu-tabs tabs">
                <li class="selected"><a href="#"  data-tab="tab-general">Основные</a></li>
                <li><a href="#"  data-tab="tab-products">Типы продуктов</a></li>
            </ul>
            <div class="tab-content">
                <!-- Основные настройки продуктов -->
                <div class="block double-padded" id="tab-general">
                    <h2>Основные настройки</h2>
                    <!--  Количество отзывов на странице -->
                    <div class="field">
                        <div class="name">
                            Плагин включен
                        </div>
                        <div class="value">
                            <input type="hidden" name="settings[status]" value="0">
                            <input type="checkbox" name="settings[status]" value="1"{if isset($settings.status) && $settings.status} checked{/if}>
                            <div class="fractional-mess">
                                {if isset($settings.status) && $settings.status==1}
                                Внимание! При выключении плагина могут отображаться неверные данные в заказе, т.к. при эмуляции дробного количества все данные записываются с определенной кратностью!
                                {else}
                                Внимание! При включении плагина будут декорированы некоторые модели базы данных и некоторые Экшены в админ части приложения!
                                {/if}
                            </div>
                        </div>
                    </div>
                    <div class="field">
                        <div class="name">
                           Кратное количество
                        </div>
                        <div class="value">
                            <select name="settings[multiplicity_conversion]">
                                <option value="0" {if isset($settings.multiplicity_conversion) && $settings.multiplicity_conversion=='0'} selected{/if}>Отключено</option>
                                <option value="1" {if isset($settings.multiplicity_conversion) && $settings.multiplicity_conversion=='1'} selected{/if}>Только на витрине</option>
                                <option value="2" {if !isset($settings.multiplicity_conversion) || $settings.multiplicity_conversion=='2'} selected{/if}>Везде</option>
                            </select>
                            <p class="hint">
                                Данная настройка управляет приведением количества товара к установленной кратности.
                                <br><br><strong>Отключено</strong> - Кратность товаров будет проигнорирована, возможно будет вводить произвольное количество.
                                <br><strong>Только на витрине</strong> - ввод кратного количества будет только для пользователей витрины,
                                в бекенде в заказе можно будет вводить любое количество.
                                <br><strong>Везде</strong> - ввод кратного количества будет работать везде.
                            </p>
                        </div>
                    </div>
                    <div class="field">
                        <div class="name">
                           Предупреждение о кратности
                        </div>
                        <div class="value">
                            <input type="hidden" name="settings[multiplicity_error]" value="0">
                            <input type="checkbox" name="settings[multiplicity_error]" value="1"
                                   {if !isset($settings.multiplicity_error) || $settings.multiplicity_error=='1'} checked{/if}>
                            <p class="hint">При вводе пользователем на витрине не кратного количества ему будет показано предупреждение о кратности товара.
                            <br>В бекенде при редактировании заказа при вводе не кратного количества заказ не будет сохранен до приведения количества к кратному, а также будет показано предупреждение.
                            </p>
                        </div>
                    </div>
                  <div class="field">
                        <div class="name">
                             Преобразование количества
                        </div>
                        <div class="value">
                            <input type="hidden" name="settings[collapse_quantity]" value="0">
                            <input type="checkbox" name="settings[collapse_quantity]" value="1"
                            {if isset($settings.collapse_quantity) && $settings.collapse_quantity=='1'} checked{/if}>
                            <span class="hint">При включении <strong>для плагинов оплаты и печатных форм</strong> для дробных позиций заказа
                            количество будет перенесено в название, в итоге будет показывваться позиция в количеством 1, а в названии будет добавлено количество реальное.
                            <br><strong>Пример: Линолеум (3.4 м2) кол: 1, Сахар (7.4 кг) кол: 1</strong></span>
                        </div>
                    </div>
                    <!--
                  <div class="field">
                      <div class="name">Контроль ввода количества в обход темы</div>
                      <div class="value">
                          <input type="hidden" name="settings[quantity_control]" value="0">
                          <input type="checkbox" name="settings[quantity_control]" value="1" {if isset($settings['quantity_control']) && $settings['quantity_control'] == 1} checked="checked"{/if} />
                          <p class="hint">
                              При включении на витрине будет отменен контроль ввода и коррекции количества(кнопки +-) через тему и будет передан на обработку плагину.
                          </p>
                      </div>
                      <div class="value quantity_control"  {if !isset($settings['quantity_control']) || $settings['quantity_control'] < 1} style="display:none;"{/if}>
                          <input type="hidden" name="settings[quantity_button_minus]" value="0">
                          <input type="checkbox" name="settings[quantity_button_minus]" value="1" {if isset($settings['quantity_control']) && $settings['quantity_control'] == 1} checked="checked"{/if} />
                          <p class="hint">
                              При включении на витрине будет отменен контроль ввода и коррекции количества(кнопки +-) будет передан на обработку плагину в обход контроля темы дизайна.
                          </p>
                      </div>
                  </div>-->
                </div>
                <!-- Настройки  продуктов -->
                <div class="block double-padded" id="tab-products" style="display: none;">
                    <h2>Настройки по типам товаров</h2>
                    {$product_types_settings = []}
                    {if array_key_exists('product_type',$settings)}
                    {$product_types_settings = $settings.product_type}
                    {/if}
                    <div class="product-types-settings">
                        <p>Данные настройки также можно переопределить в каждом товаре.</p>
                        <p class="hint">Кратность для покупки - при вводе пользователем не кратного количества, количество будет округлено до кратного в большую сторону.
                            Например: вы поставили кратность 0.25 , при вводе покупателем не кратного количества "0.60" , количество будет изменено до кратного 0.75.
                            Также при увеличении и уменьшении количества через кнопки +- количество будет изменяться согласно установленной кратности.</p>
                    {foreach $product_types as $_type}
                    {$type_settings = []}
                    {if array_key_exists($_type['id'], $product_types_settings)}
                    {$type_settings = $product_types_settings[$_type['id']]}
                    {/if}
                    <div class="product-type-settings">
                        <h4>{$_type['name']}</h4>
                        <div class="field">
                            <div class="name">Единица продукта</div>
                            <div class="value no-shift">
                                <select name="settings[product_type][{$_type['id']}][unit]" class="product-type-unit-select">
                                    {foreach $dimension->getList() as $type => $data}
                                    <optgroup label="{$data['name']}"></optgroup>
                                    {foreach $data['units'] as $unit_id => $unit_data}
                                    <option value="{$unit_id}" data-type="{$type}" data-unit_multiplicity="{$unit_data['unit_multiplicity']}"
                                            {if isset($type_settings['unit']) && $type_settings['unit'] == $unit_id} selected{/if}>{$unit_data['name']}</option>
                                    {/foreach}
                                    {/foreach}
                                </select>
                                <br><input type="hidden" name="settings[product_type][{$_type['id']}][unit_lock]" value="0">
                                <input type="checkbox" name="settings[product_type][{$_type['id']}][unit_lock]" value="1"
                                       {if isset($type_settings['unit_lock']) && $type_settings['unit_lock'] == 1} checked{/if}>
                                <span class="hint">Запретить менять в товаре</span>
                            </div>
                        </div>
                        <div class="field">
                            <div class="name">Кратность для покупки</div>
                            <div class="value no-shift">
                                <select name="settings[product_type][{$_type['id']}][unit_multiplicity]" class="product-type-unit_multiplicity-select">
                                    {foreach $dimension->getRates()  as $type => $data}
                                    <optgroup label="{$data['name']}"></optgroup>
                                    {foreach $data['units'] as  $rate}
                                    <option value="{$rate}"  data-type="{$type}"
                                            {if isset($type_settings['unit_multiplicity']) && $type_settings['unit_multiplicity'] == $rate} selected{/if} class="rate-{$type}">{$rate}</option>
                                    {/foreach}
                                    {/foreach}
                                </select>
                                <br><input type="hidden" name="settings[product_type][{$_type['id']}][multiplicity_lock]" value="0">
                                <input type="checkbox" name="settings[product_type][{$_type['id']}][multiplicity_lock]" value="1"
                                       {if isset($type_settings['multiplicity_lock']) && $type_settings['multiplicity_lock'] == 1} checked{/if}>
                                <span class="hint">Запретить менять в товаре</span>
                            </div>
                        </div>
                    </div>
                    {/foreach}
                    </div>
                </div>

            </div>
        </div>
        <div class="field">
            <div class="value submit">
                <input type="submit" class="button green" value="[s`Save`]">
                <span id="plugins-settings-status" style="display:none"></span>
            </div>
        </div>
    </form>
</div>
<style>
    .fractional-mess {
        max-width: 500px;
        color: #f22;
        padding: 20px;
        font-size: 16px;
        border: 1px #ccc solid;
        margin-top: 10px;
    }
</style>

<script type="text/javascript">
    if(typeof floatval!='function') {
        function floatval(val) {
            if(val!==null && val !== undefined && val.toString().match(/,/)) {
                val = val.replace(/,/,'.');
                return parseFloat(val);
            }
            if(!isNaN(val)) {
                return parseFloat(val);
            } else {
                return 0.0;
            }
        }
    }
$(document).ready(function () {
    $("#plugin-settings-form").submit(function () {
        var f = $(this);
        var action = f.attr('action');
        var msg = '';

        $.ajax({
            url: action,
            data: f.serialize(),
            dataType: "json",
            type: "post",
            success: function(response) {

                if(!response.data.error) {
                    msg = '<i style="vertical-align:middle" class="icon16 yes"></i> Сохранено';
                } else {
                    msg = '<i style="vertical-align:middle" class="icon16 cross"></i> Ошибка';
                }

            },
            error: function(jqXHR, errorText, errorThrown) {
                if(console){
                    console.log(jqXHR, errorText, errorThrown);
                }
            },
            complete: function() {
                var status =  $('#plugins-settings-status');
                status.html(msg);
                status.show();
                setTimeout(function(){
                    status.hide(1500);
                    status.empty();
                }, 3000);
            }
        });
        return false;
    });
    /* Табы продуктов */
    $('.menu-tabs a').click(function () {
        $(this).closest('.menu-tabs').find('li').removeClass('selected');
        $(this).closest('li').addClass('selected');
        $(this).closest('.blocks-tabs').find('.tab-content').children().hide();
        var tab = $(this).data('tab');
        $('#'+tab).show();
    });
    $('.zzzfractional-update-message')
            .append('<img src="//genasyst.ru/images/plugins/zzzfractional_alfa.png">');
    $('.product-type-unit-select').change(function () {
        var self = $(this);
        var rateselect = self.closest('.product-type-settings').find('.product-type-unit_multiplicity-select');
        if(self.find('option:selected').data('type')=='items') {
            var fractional = false;
            var val = rateselect.val();
            var selected = false;
            rateselect.find('option').each(function () {
                /* небольшой костыль для переопределения */
                if($(this).data('type') != 'item')  {
                    if($(this).attr('value') == val) {
                        fractional = true;
                        selected = false;
                    }
                    $(this).attr('disabled', true);
                } else if(!selected) {
                    rateselect.val($(this).attr('value'));
                    selected = true;
                }
            });
        } else {
            var unit_multiplicity = self.find('option:selected').data('unit_multiplicity');
            unit_multiplicity = floatval(unit_multiplicity);
            var rate = function(quantity,multiplicity) {
                var num = quantity/multiplicity.toFixed(3);
                num = num.toFixed(3);
                return (num%1==0);
            };
            rateselect.find('option').each(function () {
                if($(this).data('type') != 'item')  {
                    var val =  $(this).val();
                    val = floatval(val);
                    if(val >= unit_multiplicity && rate(val,unit_multiplicity)) {
                        $(this).attr('disabled', false);
                    } else {
                        $(this).attr('disabled', true);
                    }
                }
            });
        }
    });
});
</script>



